use clingo;

pub struct Translator<'a>
{
	problem: &'a str,
}

struct Logger;

impl clingo::Logger for Logger
{
	fn log(&mut self, code: clingo::Warning, message: &str)
	{
		log::warn!("clingo warning ({:?}): {}", code, message);
	}
}

impl clingo::StatementHandler for Translator<'_>
{
	fn on_statement(&mut self, statement: &clingo::ast::Statement) -> bool
	{
		println!("Statement in StatementHandler: {:#?}\n", statement);
        true
	}
}

impl Translator<'_>
{
	pub fn new() -> Self
	{
		Self
		{
			problem: "this string is irrelevant",
		}
	}

	pub fn translate(&mut self)
	{
		// Broken input program
        let program = "p(X) :- X >= 1.";

        // OK input programs
        // let program = "p(X) :- X > 1.";
        // let program = "p(X) :- X <= 1.";

		println!("Read program: {}", program);

        // This is a clingo-rs function, it takes the program string and eventually calls
        // the on_statement from the StatementHandler trait.
        // However, the clingo ast is incorrect upon entry to this function
		let _x = clingo::parse_program_with_logger(&program, self, &mut Logger, std::u32::MAX);
    }
}

fn main() 
{
    let mut translator = Translator::new();
    translator.translate();
}
